/* 
 * File:   arraylist.h
 * Author: Arthur Brandao
 *
 * Created on 14 novembre 2018
 */

#ifndef ARRAYLIST_H
#define ARRAYLIST_H

/* --- Include --- */
#include "constante.h"

/* --- Structure --- */
typedef struct al_node al_node;
struct al_node{
    char* key;
    char* val;
    al_node* prev;
    al_node* next;
};
typedef struct{
    al_node* first;
    al_node* last;
    int size;
}arraylist;

/* --- Fonctions --- */
void arraylist_ini(arraylist*);
al_node* arraylist_add(arraylist*, char*, char*);
al_node* arraylist_search(arraylist*, char*);
char* arraylist_get(arraylist*, char*);
int arraylist_getint(arraylist*, char*);
double arraylist_getdouble(arraylist*, char*);
void arraylist_delete(arraylist*, al_node*);
boolean arraylist_remove(arraylist*, char*);
void arraylist_clean(arraylist*);

#endif /* ARRAYLIST_H */

